SystemOrganization addCategory: #'TKSave-Apps'!
SystemOrganization addCategory: #'TKSave-Base'!
SystemOrganization addCategory: #'TKSave-Tests'!
SystemOrganization addCategory: #'TKSave-Connection'!

!String methodsFor: '*tksave' stamp: 'tk 5/15/2008 15:45'!
asDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('description',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 6/19/2008 15:30'!
asSqSaveDescriptionSelector
	| selector |
	selector := self copy.
	selector at: 1 put: (((self at: 1) asUppercase)).
	^('persistenceDescription',selector) asSymbol.! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
asSqSaveTableName
	| |
	^self decamelized,'s'! !

!String methodsFor: '*tksave' stamp: 'tk 7/7/2008 15:19'!
decamelized
	| result nextChar |
	result := WriteStream on: String new.
	self withIndexDo: [:char :index |
		nextChar := self at: (index + 1) ifAbsent: [$t].
		(((nextChar isLowercase) and: [char isUppercase]) and:[index > 1]) ifTrue: [
			result nextPutAll: '_'.
		].
		result nextPutAll: char asLowercase asString.
	].
	^result contents! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:46'!
magritteDescriptionClass
	^#MAStringDescription! !

!String methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:50'!
magritteDescriptionDefaultValue
	^''''''! !

WAComponent subclass: #SqSaveTestComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Apps'!

!SqSaveTestComponent class methodsFor: 'as yet unclassified' stamp: 'tk 4/29/2008 15:44'!
canBeRoot
	^true! !

!SqSaveTestComponent methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:53'!
renderContentOn: html 
	html anchor
		callback: [ self call: SqSaveTestObject new asComponent addValidatedForm ];
		with: 'new'! !

Object subclass: #SqSaveBase
	instanceVariableNames: 'oid'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 15:00'!
allClassTableColumns
	| |
	^(self descriptionHandler allTableColumnsForClass: self) ! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/10/2008 17:28'!
baseClass
	| |
	self superclass = SqSaveBase ifTrue: [
		^self
	] ifFalse: [
		^self superclass baseClass
	]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName
	^self descriptionHandler columnNameForInstVar: ivarName ofClass: self.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:44'!
createClassDescriptionFor: aSampleObject
	^(self descriptionHandler for: aSampleObject) createDescriptionMethods.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:37'!
descriptionHandler
	^ SqSaveMagritteDescriptionHandler! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/5/2008 13:49'!
doesNotUnderstand: aMessage
	| selector all attributes finderMethod startWord |
	selector := aMessage selector.
	finderMethod := selector prefixMatchesRegex: 'find[[:alpha:]]*By'.
	finderMethod ifTrue: [
		all := selector prefixMatchesRegex: 'findAllBy[[:upper:]]+'.
		all ifTrue:[startWord := 'findAllBy'] ifFalse: [startWord := 'findBy'].
		attributes := self findAttributesInSelector: aMessage selector beginWith: startWord.
		attributes ifNil: [
			^super doesNotUnderstand: aMessage.
		] ifNotNil: [
			^self performSearchFor: attributes withValues: (aMessage arguments) andReturnAll: all.
		].
	] ifFalse: [
		^super doesNotUnderstand: aMessage.
	].
	
	
	! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:15'!
findAttributesInSelector: aSelector beginWith: aString
	| elements searchedAttributes attrName |
	elements := aSelector subStrings: ':'.
	searchedAttributes := OrderedCollection new.
	elements at: 1 put: ((elements first) allButFirst: (aString size)).
	elements do:[ :el |
		attrName := el.
		(el beginsWith: 'and') ifTrue:[attrName := el allButFirst: 3].
		attrName at: 1 put: ((attrName first) asLowercase).
		(self allInstVarNames includes: attrName) ifTrue: [
			searchedAttributes add: attrName.	
		] ifFalse: [
			^nil
		]
	].
	^searchedAttributes! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/24/2008 15:36'!
getConnection
	^SqSaveConnectionManager getInstance getConnectionForCategory: ((self category subStrings: '-') first). ! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 19:50'!
performSearchFor: instVars withValues: values andReturnAll: aBool
	| limit results argumentDictionary |
	aBool ifFalse: [limit := 1].
	argumentDictionary := (SqSaveTableStructureHandler for: (self new)) buildSearchFor: instVars withValues: values.
	results := self getConnection performSearchForObjectsOfClass: self  withArguments: argumentDictionary andLimit: limit.
	aBool ifTrue: [^results] ifFalse: [^results at: 1 ifAbsent:[nil]]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:08'!
persistedInstVars
	| unpersistedVariables superClass |
	unpersistedVariables := Set withAll: self unpersistedInstVars.
	superClass := self superclass.
	[superClass ~= SqSaveBase] whileTrue: [
		unpersistedVariables addAll: superClass unpersistedInstVars.
		superClass := superClass superclass.
	].
	^self allInstVarNames difference: unpersistedVariables.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:20'!
persistenceInheritanceMode
	^#singleTableInheritance! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:25'!
reServeType
	^#unsignedInteger! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/13/2008 15:34'!
tableForClassExists
	^self getConnection queryForTableExistance: self tableName.! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:12'!
tableName
	(self descriptionHandler inheritanceModeForClass: self) = #singleTableInheritance 
		ifTrue: 
			[ self superclass = SqSaveBase 
				ifTrue: [ ^ self name asSqSaveTableName asEscapedSql ]
				ifFalse: [ ^ self superclass tableName ] ]
		ifFalse: [ ^ self name asSqSaveTableName asEscapedSql ]! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 14:08'!
unpersistedInstVars
	^#('oid')! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 6/19/2008 16:56'!
updateTableColumns: aDictionary
	| connection |
	connection := self getConnection.
	aDictionary associationsDo: [:assoc |
		connection executeQuery: (
			connection queryToAlterColumns: assoc forTable: self tableName
		).
	].
	! !

!SqSaveBase class methodsFor: 'as yet unclassified' stamp: 'tk 5/20/2008 14:14'!
useInstVarAccessors
	^false! !

!SqSaveBase methodsFor: 'nil' stamp: 'tk 7/15/2008 15:10'!
= anObject
	(anObject isKindOf: (self class)) ifFalse:[
		^false.
	].
	^anObject oid = self oid.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:28'!
asSqlValueString
	^(self oid) asSqlValueString! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:55'!
createRecord
	self oid: (SqSaveTableStructureHandler for: self) insertObject.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:17'!
descriptionHandler
	^self class descriptionHandler for: self! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 16:08'!
destroy
	| |
	self oid ifNotNil: [
		 (SqSaveTableStructureHandler for: self) deleteObject	
	].
	! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:13'!
escapedValueForInstanceVariable: iVar 
	| ivarValue |
	iVar = self class getConnection class sqSaveInheritanceTypeField ifTrue: [ ^ self class name asSqlValueString ].
	ivarValue := self getValueOfInstVarNamed: iVar.
	(ivarValue class inheritsFrom: SqSaveBase) ifTrue: [ ivarValue isDirty ifTrue: [ ivarValue save ] ].
	(ivarValue respondsTo: #asSqlValueString) 
		ifTrue: [ ^ ivarValue asSqlValueString ]
		ifFalse: 
			[ self error: 'unstorable instance variable of type' , ivarValue class name , '!! Implement #asSqlValueString' ]! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 11:52'!
getValueOfInstVarNamed: iVar
	| ivarValue |
	(self respondsTo: iVar asSymbol) ifTrue: [
		(self class useInstVarAccessors) ifTrue: [
			ivarValue := self perform: iVar asSymbol.	
		] ifFalse: [
			ivarValue := self instVarNamed: iVar asSymbol.
		]
	].
	^ivarValue! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:13'!
hash
	^self oid ifNil: [0] ifNotNil: [self oid]! !

!SqSaveBase methodsFor: 'accessing' stamp: 'tk 6/16/2008 13:35'!
isDirty
	"TODO: enhance me with some sort of check to determine whether an object needs restoring"
	^self newRecord! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 15:16'!
lazilyInitializedVariables
	^#()! !

!SqSaveBase methodsFor: 'accessing' stamp: 'tk 5/26/2008 15:18'!
newRecord
	^self oid isNil.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:56'!
oid
	^oid! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 15:57'!
oid: anInteger
	oid := anInteger.! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:03'!
save
	" check if the table already exisits - this is for dev mode only - FACTOR OUT"
	| alteredColumns |
	alteredColumns := self class createClassDescriptionFor: self.
	self class tableForClassExists 
		ifTrue: [ self class updateTableColumns: alteredColumns ]
		ifFalse: [ (SqSaveTableStructureHandler for: self) createTableStructure ].

	"update the record if it is already present in the database, otherwhise create it"
	self newRecord 
		ifTrue: [ self createRecord ]
		ifFalse: [ self updateRecord ]! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:19'!
setInstVarNamed: ivarName withValue: anObject
	| object lazy |
	"only set instvars of ourselves and ignore those of subclasses"
	(self class allInstVarNames includes: ivarName) ifTrue: [
		lazy := (self lazilyInitializedVariables includes: ivarName).
		object := (self descriptionHandler) 
						adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy:lazy.
		(self class useInstVarAccessors) ifTrue: [
			self perform: ((ivarName,':') asSymbol) with: object.
		] ifFalse: [
			self instVarNamed: ivarName put: object.
		]
	].! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 5/21/2008 16:15'!
tableName
	^self class tableName! !

!SqSaveBase methodsFor: 'as yet unclassified' stamp: 'tk 6/16/2008 17:14'!
updateRecord
	"self oid: (self class getConnection createObject: self)."
	! !

SqSaveBase subclass: #SqSaveTestObject
	instanceVariableNames: 'testInteger testString testDate testSomething'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
descriptionTestDate
	^MADateDescription new
			selectorAccessor: #testDate;
			label: 'testDate';
			default: Date today;
			yourself
! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
descriptionTestInteger
	^MANumberDescription new
			selectorAccessor: #testInteger;
			label: 'testInteger';
			default: 0;
			yourself
! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
descriptionTestSomething
	^MAToOneRelationDescription new
			selectorAccessor: #testSomething;
			label: 'testSomething';
			yourself
! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
descriptionTestString
	^MAStringDescription new
			selectorAccessor: #testString;
			label: 'testString';
			default: '';
			yourself
! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
persistenceDescriptionTestDate
	^(SqSaveColumnDescription new)
	columnName: 'test_date';
	sqlType: 'DATE';
	objectClass: 'Date';
	tableName: 'sq_save_test_objects';
	canBeNull: true! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
persistenceDescriptionTestInteger
	^(SqSaveColumnDescription new)
	columnName: 'test_integer';
	sqlType: 'SMALLINT';
	objectClass: 'SmallInteger';
	tableName: 'sq_save_test_objects';
	canBeNull: true! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
persistenceDescriptionTestSomething
	^(SqSaveColumnDescription new)
	associatedClass: 'SqSaveTestObject';
	columnName: 'test_something';
	sqlType: 'INTEGER';
	objectClass: 'SqSaveTestObject';
	tableName: 'sq_save_test_objects';
	canBeNull: true! !

!SqSaveTestObject class methodsFor: 'magritte-description' stamp: 'test 7/15/2008 18:27'!
persistenceDescriptionTestString
	^(SqSaveColumnDescription new)
	columnName: 'test_string';
	sqlType: 'VARCHAR(254)';
	objectClass: 'ByteString';
	tableName: 'sq_save_test_objects';
	canBeNull: true! !

!SqSaveTestObject class methodsFor: 'persistence-description' stamp: 'test 7/15/2008 18:27'!
persistenceInheritanceMode
	^#classTableInheritance! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate
	^ testDate! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testDate: anObject
	testDate := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger
	^ testInteger! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testInteger: anObject
	testInteger := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething
	^ testSomething! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testSomething: anObject
	testSomething := anObject! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString
	^ testString! !

!SqSaveTestObject methodsFor: 'accessing' stamp: 'tk 4/29/2008 16:44'!
testString: anObject
	testString := anObject! !

SqSaveTestObject subclass: #SqSaveTestObjectChild
	instanceVariableNames: 'testSubString testUnstoredVariable'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectChild class methodsFor: 'magritte-description' stamp: 'tk 7/7/2008 16:30'!
unpersistedInstVars
	^#('testUnstoredVariable')! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString
	^ testSubString! !

!SqSaveTestObjectChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testSubString: anObject
	testSubString := anObject! !

SqSaveTestObjectChild subclass: #SqSaveTestObjectEvenDeeperChild
	instanceVariableNames: 'testExtremelyDeepSubString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString
	^ testExtremelyDeepSubString! !

!SqSaveTestObjectEvenDeeperChild methodsFor: 'accessing' stamp: 'tk 6/5/2008 16:09'!
testExtremelyDeepSubString: anObject
	testExtremelyDeepSubString := anObject! !

Object subclass: #SqSaveConnectionManager
	instanceVariableNames: 'connectionSpecificationDictionary connectionPool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

SqSaveConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

SqSaveConnectionManager class
	instanceVariableNames: 'ConnectionManager'!

!SqSaveConnectionManager class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:35'!
getInstance
	ConnectionManager ifNil: [
		ConnectionManager := self new.	
	].
	^ConnectionManager! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool
	^ connectionPool! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionPool: anObject
	connectionPool := anObject! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary
	^ connectionSpecificationDictionary! !

!SqSaveConnectionManager methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:39'!
connectionSpecificationDictionary: anObject
	connectionSpecificationDictionary := anObject! !

!SqSaveConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/6/2008 10:31'!
getConnectionForCategory: aCategoryName
	| cSpec  |
	cSpec := self connectionSpecificationDictionary at: aCategoryName ifAbsent: nil.
	cSpec ifNotNil: [
		^self getConnectionFromQueue: aCategoryName for: cSpec.
	].
	self error: 'no connection data specified'.
	^nil
	! !

!SqSaveConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 18:03'!
getConnectionFromQueue: aCategoryName for: aConnectionSpecification
	| availableConnections |
	availableConnections := self connectionPool at: aCategoryName ifAbsent: nil.
	availableConnections ifNil: [
	self connectionPool at: aCategoryName put: {((Smalltalk at: aConnectionSpecification driverClass) 
			onHost: aConnectionSpecification hostname 
			port: aConnectionSpecification port  
			withUser: aConnectionSpecification username  
			password: aConnectionSpecification password  
			database: aConnectionSpecification database)}
	].
	^availableConnections first.
	! !

!SqSaveConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:37'!
initialize
	connectionSpecificationDictionary := Dictionary new.
	connectionPool := Dictionary new.! !

!SqSaveConnectionManager methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 14:42'!
setupConnectionSpecification: aConnectionSpecification for: aCategoryName
	self connectionSpecificationDictionary at: aCategoryName put: aConnectionSpecification! !

Object subclass: #SqSaveConnectionSpecification
	instanceVariableNames: 'username password database port hostname driverClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: 'localhost'.! !

!SqSaveConnectionSpecification class methodsFor: 'as yet unclassified' stamp: 'tk 5/5/2008 17:29'!
user: aUsername password: aPassword port: aPortNumber database: aDatabaseName hostname: aHostname driver: aDriverClassName
	^self new
		username: aUsername;
		password: aPassword;
		port: aPortNumber;
		database: aDatabaseName;
		driverClass: aDriverClassName;
		hostname: aHostname.! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database
	^ database! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
database: anObject
	database := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass
	^ driverClass! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:51'!
driverClass: anObject
	driverClass := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname
	^ hostname! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 17:28'!
hostname: anObject
	hostname := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password
	^ password! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
password: anObject
	password := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port
	^ port! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
port: anObject
	port := anObject! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username
	^ username! !

!SqSaveConnectionSpecification methodsFor: 'accessing' stamp: 'tk 5/5/2008 14:46'!
username: anObject
	username := anObject! !

Object subclass: #SqSaveDescriptionHandler
	instanceVariableNames: 'sampleObject alteredColumns'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveDescriptionHandler commentStamp: 'tk 5/22/2008 10:47' prior: 0!
A TKSaveDescriptionHandler is an abstract base class for the description handlers of the TKSave framework.
It defines methods that subclasses have to implement in order to be able to create, update, delete and read the descriptions of TKSaveBase subclasses.
It is therefore ment to provide a clean abstraction for the problem of describing the way objects are being stored within the database.

Instance Variables
	sampleObject:		anObject that determines how the descriptors will loke like
			
sampleObject
	- xxxxx!

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 16:03'!
allTableColumnsForClass: aClass
	| variables columnDict |
	variables := self perform: (((self inheritanceModeForClass: aClass),'TableColumnsForClass:') asSymbol) with: aClass.
	columnDict := Dictionary new.
	variables do: [:var |
		columnDict at: var put: ((aClass respondsTo: var asSqSaveDescriptionSelector) ifTrue: [
			aClass perform: var asSqSaveDescriptionSelector
		] ifFalse: [
			((SqSaveColumnDescription new) columnName: (var decamelized))
		])
	].
	^columnDict
! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:20'!
classTableInheritanceTableColumnsForClass: aClass 
	| instVars |
	instVars := Set newFrom: (aClass instVarNames difference: aClass unpersistedInstVars).
	aClass superclass = SqSaveBase ifTrue: [ instVars add: SqSaveDriver sqSaveInheritanceTypeField ].
	^ instVars! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:06'!
columnNameForInstVar: ivarName ofClass: aClass
	^ivarName decamelized! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 15:02'!
concreteTableInheritanceTableColumnsForClass: aClass 
	| instVars superClass |
	instVars := Set withAll: (aClass instVarNames difference: aClass unpersistedInstVars).
	superClass := aClass superclass.
	[ superClass = SqSaveBase ] whileFalse: 
		[ instVars addAll: (superClass instVarNames difference: superClass unpersistedInstVars).
		superClass := superClass superclass ].
	^ instVars! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:50'!
for: aSampleObject
	^self new
		sampleObject: aSampleObject.! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 16:19'!
inheritanceModeForClass: aClass
	^aClass persistenceInheritanceMode! !

!SqSaveDescriptionHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:20'!
singleTableInheritanceTableColumnsForClass: aClass 
	| classes sClass allInstVars |
	classes := Set newFrom: aClass allSubclasses.
	classes add: aClass.
	sClass := aClass superclass.
	[ sClass = SqSaveBase ] whileFalse: 
		[ classes add: sClass.
		sClass := sClass superclass ].
	allInstVars := Set new.
	classes do: 
		[ :klass | 
		allInstVars addAll: (klass instVarNames difference: klass unpersistedInstVars) ].
	classes ifNotEmpty: [ allInstVars add: SqSaveDriver sqSaveInheritanceTypeField ].
	^ allInstVars! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/11/2008 15:54'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	^self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns
	^ alteredColumns! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:51'!
alteredColumns: anObject
	alteredColumns := anObject! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/14/2008 17:14'!
columnDescriptionFor: ivarName
	self subclassResponsibility! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:56'!
compileMethodCode: code intoClass: aClass
	| |
	(aClass organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		aClass organization addCategory: (self descriptorMethodCategory).
	].
	aClass class compile: code classified: (self descriptorMethodCategory).
	! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:58'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass
	^''! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/18/2008 17:58'!
createDescriptionMethods
	"In order to not force everybody to implement the self describing functonality, just return an empty array with changed columns here"
	^Dictionary new! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:52'!
descriptorMethodCategory
	^'auto-generated-description'! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/26/2008 17:37'!
determineSqlTypeForObject: anObject 
	| connection sqlType classResolved currentClass |
	connection := self sampleObject class getConnection.
	(anObject class inheritsFrom: SqSaveBase) 
		ifTrue: [ sqlType := connection integer ]
		ifFalse: 
			[ classResolved := false.
			currentClass := anObject class.
			[ classResolved or: [ currentClass = Object ] ] whileFalse: 
				[ (connection respondsTo: currentClass name withFirstCharacterDownshifted) 
					ifTrue: 
						[ sqlType := connection perform: currentClass name withFirstCharacterDownshifted.
						classResolved := true ]
					ifFalse: [ currentClass := currentClass superclass ] ] ].
	^ sqlType! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:14'!
findDifferingColumns
	"Determine which columns need to be altered and collect their new types"	
	^self subclassResponsiblity! !

!SqSaveDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 14:10'!
getIvarValue: ivn
	| anObject |
	anObject := nil.
	(self sampleObject class allInstVarNames includes: ivn) ifTrue: [
		(self sampleObject class useInstVarAccessors) ifTrue: [
			anObject := self sampleObject perform: ivn asSymbol.
		] ifFalse: [
			anObject := self sampleObject instVarNamed: ivn asSymbol.
		].
	].
	^anObject! !

!SqSaveDescriptionHandler methodsFor: 'printing' stamp: 'tk 6/19/2008 14:17'!
indent: noOfTabs
	| indent |
	indent := String cr.
	0 to: noOfTabs do: [ :i |
		indent := indent, String tab.
	].
	^indent! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 6/18/2008 17:50'!
initialize
	super initialize.
	alteredColumns := Dictionary new.! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 5/22/2008 10:38'!
sampleObject
	^ sampleObject! !

!SqSaveDescriptionHandler methodsFor: 'accessing' stamp: 'tk 5/22/2008 10:38'!
sampleObject: anObject
	sampleObject := anObject! !

SqSaveDescriptionHandler subclass: #SqSaveMagritteDescriptionHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveMagritteDescriptionHandler commentStamp: 'tk 6/19/2008 15:22' prior: 0!
A TKSaveMagritteDescriptionHandler is  .

Instance Variables
!

!SqSaveMagritteDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/1/2008 14:08'!
adaptObject: anObject toSpecificationOfInstVar: ivarName andDoItLaziliy: aBoolean
	| persistenceObject |
	aBoolean ifTrue: [
		^self error: 'create proxy object handling'
	] ifFalse: [
		(self sampleObject class respondsTo: (ivarName asSqSaveDescriptionSelector) asSymbol) ifTrue: [
			persistenceObject := self sampleObject class perform: ivarName asSqSaveDescriptionSelector.
			^persistenceObject adaptObject: anObject.
		] ifFalse: [
			^nil
		].
		
	].
	! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:15'!
columnDescriptionFor: ivarName
	^self sampleObject class perform: ivarName asSqSaveDescriptionSelector.! !

!SqSaveMagritteDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/15/2008 11:48'!
createColumnDescriptionForObject: anObject withLabel: aLabel linkedTo: aClass storedInTableNamed: tableName
	| column sqlType |
	column := SqSaveColumnDescription new.
	sqlType := self determineSqlTypeForObject: anObject.
	column
		columnName: aLabel decamelized;
		objectClass: anObject class name asSymbol;
		tableName: tableName;
		sqlType: sqlType.
	aClass ifNotNil: [ column associatedClass: aClass ].
	^ column creationCode! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 13:51'!
createDescriptionMethods
	| anObject targetClass |
	self sampleObject class persistedInstVars do:[ :ivn |
		anObject := self getIvarValue: ivn.
		targetClass := self findTargetClassForDescriptorOfIvarNamed: ivn.
		anObject ifNotNil: [
			(targetClass respondsTo: (ivn asDescriptionSelector)) ifFalse:[
				self createDescriptorNamed: ivn asDescriptionSelector for: anObject withLabel: ivn inClass: targetClass.
			].
			(targetClass respondsTo: (ivn asSqSaveDescriptionSelector)) ifTrue: [
				self updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass.	
			] ifFalse: [
				self createPersistenceDescriptorFor: ivn basedOn: anObject inClass: targetClass.
			]
		].
	].
	^self alteredColumns! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/4/2008 17:15'!
createDescriptorNamed: aSelector for: anObject withLabel: aLabel inClass: aClass
	| code |
	code := aSelector,String cr,(self descriptorCodeFor: aLabel basedOn: anObject),String cr.
	self compileMethodCode: code intoClass: aClass.
	! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/4/2008 17:52'!
createPersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| code |
	code := ivn asSqSaveDescriptionSelector, String cr.
	code := code, String tab, '^', (self persistenceDescriptionForObject: anObject withLabel: ivn storedInTableNamed: aClass tableName).
	self compileMethodCode: code intoClass: aClass. ! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/19/2008 15:45'!
descriptionCodeFor: anObject labeled: aLabel withClass: className
	| code |
	code := String tab,'^',className asString,' new', (self indent: 2).
	code := code, 'selectorAccessor: #', aLabel, ';',(self indent: 2).
	code := code, 'label: ''', aLabel,''';',(self indent: 2).
	(anObject respondsTo: #magritteDescriptionDefaultValue) ifTrue: [
		code := code, 'default: ', anObject magritteDescriptionDefaultValue, ';', (self indent: 2). 	
	].
	code := code, 'yourself'.
	^code! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:37'!
descriptorCodeFor: aLabel basedOn: anObject 
	| className code |
	className := anObject class name.
	(anObject respondsTo: #magritteDescriptionClass) 
		ifTrue: 
			[ code := self 
				descriptionCodeFor: anObject
				labeled: aLabel
				withClass: anObject magritteDescriptionClass ]
		ifFalse: 
			[ (anObject class inheritsFrom: Collection) 
				ifTrue: 
					[ self error: 'no handling for collection - TODO: implement me'
					"code := self descriptionCodeFor: anObject labeled: aLabel withClass: #MAToManyRelationDescription." ]
				ifFalse: 
					[ (anObject class inheritsFrom: SqSaveBase) 
						ifTrue: 
							[ code := self 
								descriptionCodeFor: anObject
								labeled: aLabel
								withClass: #MAToOneRelationDescription ]
						ifFalse: [ self error: 'unpersistable object - skip, try, whatever???' ] ] ].
	^ code! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 5/22/2008 10:53'!
descriptorMethodCategory
	^'magritte-description'! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/4/2008 17:11'!
findTargetClassForDescriptorOfIvarNamed: ivn
	| targetClass |
	targetClass := self sampleObject class.
	[targetClass ~= SqSaveBase] whileTrue: [
		(targetClass instVarNames includes: ivn) ifTrue: [^targetClass].
		targetClass := targetClass superclass.
	].
	self error: 'instance variable named ',ivn, ' could not be found in the class hierarchy of ',self sampleObject class name.
	! !

!SqSaveMagritteDescriptionHandler methodsFor: 'accessing' stamp: 'tk 7/4/2008 17:50'!
persistenceDescriptionForObject: anObject withLabel: aLabel storedInTableNamed: tableName
	| connection linkedClass |
	connection := self sampleObject class getConnection.
	linkedClass := (anObject class inheritsFrom: SqSaveBase) 
		ifTrue: [ anObject class name asSymbol ]
		ifFalse: [ nil ].
	^ self 
		createColumnDescriptionForObject: anObject
		withLabel: aLabel
		linkedTo: linkedClass
		storedInTableNamed: tableName! !

!SqSaveMagritteDescriptionHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:35'!
updatePersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass
	| description previousClass newSqlType |
	description := aClass perform: ivn asSqSaveDescriptionSelector.
	previousClass := Smalltalk at: description objectClass asSymbol.
	"if we have a subclass of our previous class, we're fine - otherwhise, we have to alter the table and the description"
	((anObject class inheritsFrom: previousClass) or: [anObject class = previousClass]) ifFalse: [
			newSqlType := self determineSqlTypeForObject: anObject.
			self alteredColumns at: description columnName put: newSqlType.
			self createPersistenceDescriptorFor: ivn basedOn: anObject inClass: aClass. 
	].	
	! !

Object subclass: #SqSaveDriver
	instanceVariableNames: 'localCache currentObject currentRow automaticTableCreation'
	classVariableNames: 'TableCache'
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveDriver class methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 16:47'!
sqSaveInheritanceTypeField
	^'sq_save_type_field'! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/7/2008 17:00'!
bodyForInsertOf: anObject
	| fields values |
	fields := ''.
	values := ''.
	anObject class allClassTableColumns associationsDo:[ :assoc |
		fields := fields, assoc value columnName, ', '.
		values := values, (anObject escapedValueForInstanceVariable: assoc key), ', '.
	].
	fields := fields allButLast:2.
	values := values allButLast:2.
	^'(',fields,') VALUES (',values,')'! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:32'!
boolean
	^'BOOLEAN'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:19'!
commitTransaction	
	self executeQuery:(self queryForCommit). .! !

!SqSaveDriver methodsFor: 'accessing' stamp: 'wh 8/17/2006 15:37'!
connection
	self subclassResponsibility.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 5/13/2008 15:17'!
connectionIsAlive
	self subclassResponsibility.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/7/2008 16:13'!
createObject: anObject
	self executeQuery:(self queryToCreateObject: anObject).
	^self lastOidFromTable: (anObject class tableName).! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/10/2006 17:01'!
createObjectLookupTable
	self executeQuery: (self objectIdTable).! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:12'!
createObjectsOfClass: aClass fromResultSet: result
	^self subclassResponsibility! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/10/2006 17:04'!
createTableForClass: aClass
	self executeQuery: (self queryToCreateTableClass:aClass).! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/13/2006 23:49'!
currentColumn
	^currentRow! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/13/2006 23:50'!
currentColumn: aRow
	currentRow := aRow.! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/10/2006 16:55'!
currentObject
	^currentObject.! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/10/2006 16:54'!
currentObject: anObject
	currentObject _ anObject.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 17:20'!
database
	self subclassResponsibility.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
date
	^'DATE'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
dateAndTime
	^'DATETIME'.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
decimalIntegerSize: m scale: d
	^'DECIMAL('m asString,',',d asString,')'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
double
	^'DOUBLE'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
float
	^'FLOAT'.! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/10/2006 01:01'!
flush
	self localCache do:[:o | o flush].! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/17/2006 22:45'!
getFromCache: oid	
	| o |
	"Returns the object from the cache of nil if the object does not exist"

	o _ (self localCache at:oid ifAbsent:[ 
		^nil.
	]).

	o isInMemory ifTrue:[
		^o
	].
	^nil.
	! !

!SqSaveDriver methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:15'!
inTransactionDo: aBlock
	self inTransactionDo: aBlock onError: [self rollback].! !

!SqSaveDriver methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:23'!
inTransactionDo: aBlock onError: anErrorBlock
	self startTransaction.
	[aBlock value] ifError: [anErrorBlock].
	self commitTransaction.
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/10/2006 17:03'!
insertObject: anObject
	self executeQuery:(self queryForInsertObject:anObject).! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
integer
	^'INTEGER'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
largeInteger
	^'BIGINT'.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 5/22/2008 17:04'!
lastOidFromTable: aTable
	self subclassResponsibility! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/8/2006 12:00'!
localCache
	^localCache! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/15/2008 15:38'!
log: aString
	Transcript show: '+++++++++++++++++++';
		show: String cr;
		show: aString;
		show: String cr.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
mediumInteger
	^'MEDIUMINT'.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 9/22/2006 10:37'!
objectForOid: anOid
	| coid |
	^(self getFromCache:anOid) ifNil:[
		coid := (self classForOid:anOid).
		coid ifNotNil:[
			^self objectForOid:anOid withClass:coid.
		] ifNil:[
			self error:'No such object stored'.
		].
	].! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 9/13/2006 15:23'!
objectForOid: anOid withClass: aClass fromDictionary: flatObject
	| newObject rawValue |
	^(self getFromCache:anOid) ifNil:[
		newObject := aClass new.
		
		newObject oid: anOid.
		self putInCache:newObject.
		aClass tableDefinition columns do:[:row | | value |
			self currentObject: newObject.
			self currentColumn: row.
			
			rawValue := flatObject at:(row symbol) ifAbsent:[''].
			rawValue ifNil:[
				value := nil.
			] ifNotNil:[
				row type needsReServeConnection ifTrue:[
					value := (row type) fromSqlValueString: rawValue withConnection: self.
				] ifFalse:[
					value := (row type) fromSqlValueString: rawValue.
				].
			].
			newObject putValue: value forSymbol:(row symbol).
			
		].	
		newObject makeClean.
		"self putInCache:newObject."
		^newObject.
	].! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/8/2006 16:31'!
objectIdTable
	self subclassResponsibility! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:34'!
oid
	^self unsignedInteger, ' PRIMARY KEY '.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:30'!
oidColumn
	"I believe this is the SQL standard but I don't think any SQL databases 
		follow it "

	^'INTEGER PRIMARY KEY GENERATED ALWAYS AS IDENTITY'! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:28'!
oidColumnCreationString
	^self subclassResponsibility! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 11:23'!
oidForRoot
	self subclassResponsiblity.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/14/2008 19:51'!
performSearchForObjectsOfClass: aClass withArguments: argumentDictionary andLimit: aLimit
	| sql result results |
	sql := 'SELECT * FROM ', (argumentDictionary keys join: ' NATURAL JOIN '), ' WHERE '.
	argumentDictionary associationsDo: [:assoc |
		assoc value associationsDo: [ :joiner |
			sql := sql, '('.
			sql := sql, ((joiner value collect: [:searchAttr |
				assoc key,'.', searchAttr key, ' = ', searchAttr value asSqlValueString
			]) join: (' ',joiner key,' ')).
			sql := sql,') AND '.
		].
	].
	sql := sql allButLast: 5.
	aLimit ifNotNil: [sql := sql, ' LIMIT ', aLimit asString].
	result := self executeQuery: (sql).
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/17/2006 22:52'!
putInCache: anObject
	| o g |
	"There has got to be a clearer way to do this. 
		1. Check the cache to see if an object is already there
			We can assume all objects in the cache are Proxy objects
		2. If it is in the cache update it with anObject
		3. If it is not in the cache check to see if this is a proxy object
			a. if it is put it in the cache
			b. If it is not put it in a proxy object and then 
				put that in the cache 
	"
	g := (self localCache at: (anObject oid) ifAbsent:[nil]).
	g ifNil:[
		anObject isReserveProxy ifTrue:[
			o := anObject.
		] ifFalse:[
			o := REServeProxyObject database: self oid: (anObject oid) class: (anObject class) object: anObject.
		]
	] ifNotNil:[
		g xxxObject: anObject.
		o := g.
	].
	
	^(self localCache at: (anObject oid) put: o).! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/15/2006 15:48'!
queryFor:queryClass
	^self queryClass new on: queryClass; connection:self;yourself.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:09'!
queryForClassForOid: anOid
	^'SELECT * FROM pxxObjectLookup WHERE ',(self escapedRowName:'objectId'),' = ',anOid asString.
	! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/10/2006 17:05'!
queryForCommit
	^'COMMIT'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:14'!
queryForDeleteObject: anObject 
	^self queryForDeleteObject: anObject whereClause: 
		((self escapedRowName:'objectId'),' = ',anObject oid).! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/17/2006 20:08'!
queryForDeleteObject: anObject whereClause: aString
	|sql|
	sql := 'DELETE FROM ', anObject tableName,
		' WHERE ',aString.

	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'tk 7/10/2008 17:15'!
queryForForeignKeyConstraint: aForeignKeyDescription ofColumn: aColumnName
	| sql |
	sql := 'FOREIGN KEY (',aColumnName,') REFERENCES '.
	sql := sql, aForeignKeyDescription referencedTable,'(', aForeignKeyDescription referencedColumns first,') '.
	aForeignKeyDescription deleteActions ifNotEmpty: [sql := sql, 'ON DELETE'].
	aForeignKeyDescription deleteActions do: [:action | sql := sql, ' ',action].
	aForeignKeyDescription updateActions ifNotEmpty: [sql := sql, 'ON UPDATE'].
	aForeignKeyDescription updateActions do: [:action | sql := sql, ' ',action].
	^sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:58'!
queryForInsertObject: anObject 
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyOfInsertFor: anObject). 
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:14'!
queryForLookupClass: aClass withOid: anOid
	^'SELECT * FROM ', aClass tableName,' WHERE ',(self escapedRowName:'objectId'),' = ',anOid asString.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:15'!
queryForLookupCollection: aClass withOid: anOid
	^'SELECT * FROM ', aClass tableName,' WHERE ',(self escapedRowName:'parentId'),' = ',anOid asString.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:38'!
queryForNewObjectOfClass: aClass
	^'INSERT INTO pxxObjectLookup (type) VALUES (''',(aClass name),''')'.
! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 6/26/2008 16:54'!
queryForObjectsOf: aClass byAttributes: argumentDictionary inTable: aTableName withLimit: limit 
	| query result results |
	query := 'SELECT * FROM ',aTableName,' WHERE '.
	((aClass descriptionHandler inheritanceModeForClass: aClass) = #singleTableInheritance) ifTrue: [
		query := query,'( ',self class sqSaveInheritanceTypeField,' = ', aClass name asSqlValueString.
		aClass allSubclasses do: [ :subClass |
			query := query,' OR ',self class sqSaveInheritanceTypeField,' = ', subClass name asSqlValueString.
		].
		query := query, ') AND '
	].
	argumentDictionary associationsDo: [:pair | 
		query := query,  pair key, ' = ', pair value asSqlValueString, ' AND '. 
	].
	query := query allButLast: 5.
	limit ifNotNil: [query := query, ' LIMIT ', limit asString].
	result := self executeQuery: query.
	results := self createObjectsOfClass: aClass fromResultSet: result.
	^results
	! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/11/2006 09:23'!
queryForRollback
	^'ROLLBACK'.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 9/12/2006 11:23'!
queryForRootLookup
	^'SELECT * FROM pxxObjectLookup WHERE root = 1 '.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/9/2006 00:26'!
queryForSetField: aField to: aValue
	^'`',aField,'` = ', aValue. 	! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/13/2006 12:41'!
queryForStartTransaction
	^'START TRANSACTION'.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/15/2008 11:53'!
queryForTableExistance: aClassName
	| result tableExists |
	"self connection close."
	"self connection initialize2."
	result := self executeQuery: 'SHOW TABLES'.
	tableExists := false.
	[result next and: [tableExists not]] whileTrue: [
		tableExists := (result valueNamed: (result columns first name)) = aClassName .
	].
	^tableExists
! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:16'!
queryForUpdateObject: anObject 
	^self queryForUpdateObject: anObject whereClause:
		 ((self escapedRowName:'objectId'),' = ',anObject oid asString).! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 23:23'!
queryForUpdateObject: anObject whereClause: aString
	|sql|
	sql := 'UPDATE ', anObject tableName, ' SET '.
	sql := sql, (self bodyOfUpdateFor:anObject).
	sql := sql, ' WHERE ',aString.

	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 9/8/2006 08:47'!
queryToAddColumn: aColumn toTable: aTable type:aType
	^'ALTER TABLE ',aTable,' ADD COLUMN ',(self escapedRowName:aColumn),' ',(self perform:(aType reServeType)).! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 6/19/2008 16:56'!
queryToAlterColumns: anAssociation forTable: tableName
	| sql |
	sql := 'ALTER TABLE ',tableName, ' MODIFY '.
	sql	:= sql, (self escapedRowName: anAssociation key), ' ', anAssociation value.
	^sql.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 5/22/2008 15:31'!
queryToCreateObject: anObject
	|sql|
	sql := 'INSERT INTO ', anObject tableName, ' '.
	sql := sql,(self bodyForInsertOf: anObject). 
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 8/16/2006 22:03'!
queryToCreateTableClass: anObject
	| sql d |
	
	d := false.
	self currentObject: anObject.
	sql := 'CREATE TABLE ',anObject tableName, ' ( '.
	anObject tableDefinition columns collect:[:row|
		self currentColumn: row.
		row type reServeValueStoredWithObject ifTrue:[
			d ifTrue:[
				sql := sql , ' , '.
			] ifFalse:[
				d := true.
			].
			
			sql := sql, (self escapedRowName:(row name)), ' ', (self perform:(row type reServeType)) , '  '.
		
		] ifFalse:[	
			row type createTableWithDbConnection: self.
		].
	].
	sql := sql , '  ) '.
	^sql.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/14/2008 14:53'!
queryToCreateTableNamed: tableName withColumns: columnDict 
	| sql type |
	sql := 'CREATE TABLE ',tableName, ' ('.
	(columnDict includesKey: 'oid') ifFalse: [
		sql := sql,'`oid` ',self oidColumn ,','.	
	].
	columnDict associationsDo: [:assoc |
		type := self smallInteger.
		assoc value sqlType ifNil:[
			(assoc key = self class sqSaveInheritanceTypeField) ifTrue: [type := self string]
		] ifNotNil: [
			type := assoc value sqlType.
		].
		sql := sql, (self escapedRowName: assoc value columnName), ' ',type.
		assoc value canBeNull ifFalse: [sql := sql, ' NOT NULL'].
		sql := sql, ','.
		assoc value foreignKey ifNotNil: [
			sql := sql, (self queryForForeignKeyConstraint: assoc value foreignKey ofColumn: assoc key), ','	
		]
	].
	sql := sql allButLast.
	sql := sql, ')'.
	^sql! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 9/8/2006 08:46'!
queryToDropColumn: aColumn fromTable: aTable
	^'ALTER TABLE ',aTable,' DROP COLUMN ',(self escapedRowName:aColumn).! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 9/12/2006 11:00'!
queryToRemoveRootFlag
	^'UPDATE pxxObjectLookup SET root = 0 '.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 16:11'!
queryToRemoveTableForClass: aClass
	| sql |
	sql := 'DROP TABLE ', aClass name.
	^sql.! !

!SqSaveDriver methodsFor: 'sql statements' stamp: 'wh 9/13/2006 11:59'!
queryToSetRootFlagForOid: anOid
	^'UPDATE pxxObjectLookup SET root = 1 WHERE ',( self escapedRowName:'objectId'),' = ''',anOid asString,''''.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 15:20'!
reServeObject
	^self unsignedInteger.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/16/2006 17:27'!
reServeObject: anObject
	self currentObject: anObject.
	anObject oid:(self oidForNewObject:anObject).
	self insertObject: anObject.
	anObject makeClean.
	self putInCache: (REServeProxyObject database: self
						oid: (anObject oid)
						class: (anObject class)
						object:anObject)! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/15/2008 16:06'!
removeObjectWithId: oid fromTable: tableName
	| sql |
	sql := 'DELETE FROM ',tableName,' WHERE oid = ',oid asString.
	self executeQuery: (sql).! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 4/29/2008 17:20'!
resetDatabase
	| |
	self executeQuery: 'DROP DATABASE ', self database.
	self executeQuery: 'CREATE DATABASE ', self database.
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:22'!
rollback
	self localCache do:[:object | object rollback ].
	self rollbackDbTransaction.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 09:24'!
rollbackDbTransaction
	self executeQuery:(self queryForRollback) .! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:16'!
serial
	self subclassResponsibility.
	! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 9/7/2006 10:17'!
setupDatabase
	self createObjectLookupTable.
	self createTableForClass: REServeTableDefinition.
	self createTableForClass: REServeRowDefinition.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
smallInteger
	^'SMALLINT'! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'tk 7/14/2008 16:18'!
startTransaction
	self executeQuery:(self queryForStartTransaction).! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/14/2008 15:42'!
storeColumns: columnDict inTable: aTableName
	self storeColumns: columnDict inTable: aTableName  andReturnOId: false.! !

!SqSaveDriver methodsFor: '*tksave' stamp: 'tk 7/14/2008 16:07'!
storeColumns: columnDict inTable: aTableName andReturnOId: aBool
	"columnDict is a Dictionary where a SqSaveColumnDescription points to the stored value"
	| sql keys values |
	sql := 'INSERT INTO ', aTableName,' ('.
	keys := ''.
	values := ''.
	columnDict associationsDo: [:assoc |
		keys := keys, assoc key, ', '.
		values := values, assoc value asString, ', '.	
	].
	sql := sql, (keys allButLast: 2), ') VALUES (', (values allButLast: 2), ')'.
	self executeQuery: (sql).
	aBool ifTrue: [
		^self lastOidFromTable: aTableName	
	].! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
string
	^self stringWithLength: 254.
	! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 23:21'!
stringWithLength: m
	^'VARCHAR(',m asString,')'.! !

!SqSaveDriver methodsFor: 'cache' stamp: 'wh 8/8/2006 12:04'!
tableCache
	 TableCache ifNil:[
		TableCache := Dictionary new.
	].
	^TableCache at: (self connectionIdenityString)
		ifAbsentPut:(Dictionary new).! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
text
	^'TEXT'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/8/2006 14:33'!
time
	^'TIME'.! !

!SqSaveDriver methodsFor: 'column types' stamp: 'wh 8/16/2006 22:18'!
unsignedInteger
	"The SQL standard does not support unsigned Integer 
		imagine my suprise "
	^'INTEGER '.! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 8/11/2006 16:13'!
updateObject: anObject
	self currentObject: anObject.
	self executeQuery:(self queryForUpdateObject:anObject).! !

!SqSaveDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 15:32'!
updateTableForClass: anObject
	"Query out the last table information"
	| s |
	
	s := (self queryFor:REServeTableDefinition) detect:[:i| i typeClass = anObject name asString].
	
	anObject tableDefinition columns do:[:c | 
		s columns detect:[:d| d name = c name] ifNone:[
			c reServeValueStoredWithObject ifFalse:[
				self currentObject: anObject.
				c type createTableWithDbConnection: self..
			] ifTrue:[
				self executeQuery:(self queryToAddColumn: (c name) toTable: (anObject tableName) type:(c type)).
			].	
			s columns add:c.
			
		].
	].		

	s columns do:[:c | 
		anObject tableDefinition columns detect:[:d| d name = c name] ifNone:[
			self executeQuery:(self queryToDropColumn: (c name) fromTable: (anObject tableName)).
			s columns remove:c.
		].
	].			
	self commitAndStart.

	! !

SqSaveDriver subclass: #SqSaveMySQLDriver
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Connection'!

!SqSaveMySQLDriver class methodsFor: 'as yet unclassified' stamp: 'wh 8/8/2006 23:11'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	^(self new ) 
		onHost: aHost 
		port: aPort 
		withUser: aUser 
		password: aPassword 
		database: aDatabase.! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
classForOid: anOid
	| result classString oc |
	oc := (self getFromCache:anOid) ifNil:[
		result := (self executeQuery:(self queryForClassForOid:anOid)).
		result collect:[:row |
			classString := row at:'type'.
		].
		^Smalltalk at: (classString asSymbol).
	].
	^oc class.
! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 8/16/2006 21:41'!
close
	connection close.! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
collection: aRServeCollectionModel withOid: anOid
	| col result |
	"I would like to abstract this a bit more but for now it remains 
		databases specific and has to be reimlimnented for each DB"
	col := OrderedCollection new.
	result := self executeQuery:
			(self queryForLookupCollection: aRServeCollectionModel withOid: anOid),
			' ORDER BY `key`'.
	
	[result next] whileTrue:[ | row |
		row := Dictionary new.
		aRServeCollectionModel tableDefinition columns do:[:r |
			r valueStored ifTrue:[
				row at:(r symbol) put: (result rawValueNamed:(r name)).
			].
		].
		col add: row.
	].
	^col.

! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:18'!
connection
	^connection! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:51'!
connectionIdenityString
	"should be in the form of driver://host:port/database "
	^'mysql://',self connection connectionSpec host, ':', 
		self connection connectionSpec port ,'/',
		self connection connectionSpec database.
! !

!SqSaveMySQLDriver methodsFor: 'as yet unclassified' stamp: 'tk 5/13/2008 15:19'!
connectionIsAlive
	^true! !

!SqSaveMySQLDriver methodsFor: '*tksave' stamp: 'tk 6/26/2008 16:24'!
createObjectsOfClass: aClass fromResultSet: result
	| results object resultDicts targetClass |
	targetClass := aClass.
	results := OrderedCollection new.
	resultDicts := OrderedCollection new.
	[result next] whileTrue: [resultDicts add: (result currentRowAsDictionary copy)].
	resultDicts do: [ :resultDict |
		targetClass := resultDicts first at: self class sqSaveInheritanceTypeField ifAbsent:[aClass name].
		targetClass := Smalltalk at: targetClass asSymbol ifAbsent: [nil].
		targetClass ifNotNil: [
			object := targetClass new.
			aClass persistedInstVars do: [:ivar | 
				object setInstVarNamed: ivar withValue: (resultDict at: (aClass columnNameForInstVar: ivar)).
				object oid: (resultDict at: 'oid').
			].
			results add: object.
		]. 
	].
	^results! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'tk 4/29/2008 17:22'!
database
	^connection connectionSpec database! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
driverClass
	^JdmConnection.! !

!SqSaveMySQLDriver methodsFor: 'as yet unclassified' stamp: 'wh 8/16/2006 22:02'!
escapedRowName: aString
	^'`',aString,'`'.! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'tk 7/15/2008 15:40'!
executeQuery: aQuery
	| |
	"self log: aQuery."
	[^(self connection createStatement) executeQuery:(aQuery)] on: Error do: [
		self connection initialize2.
		^(self connection createStatement) executeQuery:(aQuery)
	]! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:26'!
lastOidFromTable: aTable
	 | oid |
	
	"MySQL will only retrun the last ID. Postgres needs the table part"  
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/8/2006 10:20'!
newConnection
	^ self driverClass on: (self connection connectionSpec).! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 8/13/2006 23:51'!
objectForOid: anOid withClass: aClass
	| result  dRow |
	^(self getFromCache:anOid) ifNil:[
		dRow := Dictionary new.
		result := (self connection createStatement) executeQuery:
			(self queryForLookupClass: aClass withOid: anOid).
		result next.
		aClass tableDefinition columns do:[:row |
			self currentColumn: row.
			row type reServeValueStoredWithObject ifTrue:[
				dRow at:(row symbol) put: ((result rawValueNamed:(row name) asString)).
			].
		].
		result flush.
		^self objectForOid: anOid withClass: aClass fromDictionary: dRow.
	].! !

!SqSaveMySQLDriver methodsFor: 'sql statements' stamp: 'wh 9/12/2006 10:57'!
objectIdTable
	^'CREATE TABLE pxxObjectLookup (
			objectId int(11) auto_increment  PRIMARY KEY ,
			`type` VARCHAR(254) NOT NULL,
			`root` TINYINT(1) NOT NULL DEFAULT 0 ) '! !

!SqSaveMySQLDriver methodsFor: 'column types' stamp: 'wh 8/13/2006 12:21'!
oidColumn
	^'INT(11) NOT NULL PRIMARY KEY AUTO_INCREMENT '.! !

!SqSaveMySQLDriver methodsFor: '*tksave' stamp: 'tk 6/11/2008 14:32'!
oidColumnCreationString
	^'INT PRIMARY KEY NOT NULL AUTO_INCREMENT'! !

!SqSaveMySQLDriver methodsFor: 'database operations' stamp: 'wh 9/12/2006 16:27'!
oidForNewObject: anObject
	 | oid |
	(self connection createStatement) executeQuery: (self queryForNewObjectOfClass:(anObject class)).
	"Ugh MySQL driver trickery"
	(self executeQuery: 'SELECT LAST_INSERT_ID() AS OID')
		collect: [:table |
			oid := (table at: 'OID') asString asInteger. 	
		].
	^oid.
	! !

!SqSaveMySQLDriver methodsFor: 'as yet unclassified' stamp: 'wh 9/12/2006 11:36'!
oidForRoot
	| result id |
	result := (self connection createStatement) executeQuery:(self queryForRootLookup).
	result next.
	id := (result rawValueNamed:'objectId') asInteger.
	result flush.
	^id.! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/16/2006 23:39'!
onHost: aHost port: aPort withUser: aUser password: aPassword database: aDatabase
	| spec |
	Socket initializeNetwork.
	spec :=    (JdmConnectionSpec new initialize
        user: aUser; password: aPassword;
        host: (NetNameResolver addressForName: aHost);
        database: aDatabase;
        port: aPort).
	connection := (self driverClass) on: spec.
	! !

!SqSaveMySQLDriver methodsFor: 'accessing' stamp: 'wh 8/15/2006 12:16'!
queryClass
	^REServeMySQLQuery.! !

!SqSaveMySQLDriver methodsFor: 'sql statements' stamp: 'wh 8/8/2006 23:39'!
queryToCreateTableClass: anObject
	^ (super queryToCreateTableClass: anObject) , ' type = InnoDB '.! !

!SqSaveMySQLDriver methodsFor: '*tksave' stamp: 'tk 7/10/2008 16:54'!
queryToCreateTableNamed: tableName withColumns: columnDict
	^ (super queryToCreateTableNamed: tableName withColumns: columnDict) , ' ENGINE=INNODB'.! !

Object subclass: #SqSaveForeignKeyDescription
	instanceVariableNames: 'referencedColumns referencedTable updateActions deleteActions'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions
	^ deleteActions! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
deleteActions: anObject
	deleteActions := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:31'!
initialize
	super initialize.
	self updateActions: #().
	self deleteActions: #().! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns
	^ referencedColumns! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedColumns: anObject
	referencedColumns := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable
	^ referencedTable! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
referencedTable: anObject
	referencedTable := anObject! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions
	^ updateActions! !

!SqSaveForeignKeyDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:57'!
updateActions: anObject
	updateActions := anObject! !

Object subclass: #SqSavePersistenceDescriptionObject
	instanceVariableNames: 'associatedClass'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSavePersistenceDescriptionObject subclass: #SqSaveColumnDescription
	instanceVariableNames: 'columnName sqlType objectClass tableName foreignKey canBeNull'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull
	^ canBeNull! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 17:39'!
canBeNull: anObject
	canBeNull := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName
	^ columnName! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:39'!
columnName: anObject
	columnName := anObject! !

!SqSaveColumnDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/10/2008 17:45'!
creationCode
	| code obj anyInstVarSet |
	code := '(',(self class name),' new)'.
	anyInstVarSet := false.
	self class allInstVarNames do:[:ivar |
		obj := self perform: (ivar asSymbol).
		obj ifNotNil: [
			anyInstVarSet := true.
			code := code, String cr,String tab.
			code := code, ivar,': '.
			code := code, (obj isString ifTrue: [
				'''',obj asString,''';'	
			] ifFalse: [
				obj asString, ';'
			]).
		].
	].
	anyInstVarSet ifTrue: [code := code allButLast].
	^code
	! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey
	^ foreignKey! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/10/2008 16:58'!
foreignKey: anObject
	foreignKey := anObject! !

!SqSaveColumnDescription methodsFor: 'as yet unclassified' stamp: 'tk 7/10/2008 17:40'!
initialize
	super initialize.
	self canBeNull: true.! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass
	^ objectClass! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/19/2008 15:59'!
objectClass: anObject
	objectClass := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType
	^ sqlType! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 6/5/2008 14:40'!
sqlType: anObject
	sqlType := anObject! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName
	^ tableName! !

!SqSaveColumnDescription methodsFor: 'accessing' stamp: 'tk 7/4/2008 16:18'!
tableName: anObject
	tableName := anObject! !

!SqSavePersistenceDescriptionObject methodsFor: 'as yet unclassified' stamp: 'tk 6/11/2008 16:16'!
adaptObject: anObject
	self associatedClass ifNil: [
		^anObject	
	] ifNotNil: [
		^(Smalltalk at: (self associatedClass asSymbol)) findByOid: anObject 
	]! !

!SqSavePersistenceDescriptionObject methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass
	^ associatedClass! !

!SqSavePersistenceDescriptionObject methodsFor: 'accessing' stamp: 'tk 6/11/2008 16:06'!
associatedClass: anObject
	associatedClass := anObject! !

Object subclass: #SqSaveTableStructureHandler
	instanceVariableNames: 'sampleObject'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSaveTableStructureHandler subclass: #SqSaveClassTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 19:42'!
buildSearchFor: instVars withValues: values
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	
	descrHandler := self sampleObject descriptionHandler.
	targetClass := self sampleObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass getConnection class sqSaveInheritanceTypeField.
	
	instVars withIndexDo: [:ivar :index |
		(ivar = 'oid') ifTrue: [
			tableName := baseClass tableName.
			columnName := 'oid'.
		] ifFalse: [
			descr := (descrHandler columnDescriptionFor: ivar).
			tableName :=  descr tableName.
			columnName := descr columnName.
		].		
		(searchDict at: tableName ifAbsentPut: Dictionary new) at: #AND ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: (columnName -> (values at: index))
	].
	(searchDict at: baseClass tableName ifAbsentPut: Dictionary new) at: #OR ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: (typeField -> targetClass name).
	targetClass allSubclasses do: [:sc |
		((searchDict at: baseClass tableName) at: #OR) add: (typeField -> sc name).	
	].

	[targetClass ~= baseClass] whileTrue: [
		(searchDict at: targetClass tableName ifAbsentPut: Dictionary new).
		targetClass := targetClass superclass.
	].
	^searchDict! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/10/2008 17:40'!
createTableStructure
	| sampleClass connection lightOidColumn columnDict baseClass |
	sampleClass := self sampleObject class.
	baseClass := sampleClass baseClass.
	connection := sampleClass getConnection.

	"this oid column is lacking the auto increment feature, since this has to be set manually"
	"however we need a foreign key constraint to simplify maintaining  data integrity between the tables"
	lightOidColumn := (SqSaveColumnDescription new)
		columnName: 'oid';
		sqlType: connection integer;
		canBeNull: false;
		foreignKey: ((SqSaveForeignKeyDescription new)
			referencedColumns: #('oid');
			deleteActions: #(#CASCADE);
			referencedTable: baseClass tableName
		).
	
	"create the base class table first, if it does not already exist"
	baseClass tableForClassExists ifFalse: [
		connection executeQuery: (
			connection queryToCreateTableNamed: baseClass tableName 
				withColumns: baseClass allClassTableColumns
			).
	].
	
	"the create all other tables in the hierarchy"
	[sampleClass = baseClass] whileFalse: [
		sampleClass tableForClassExists ifFalse: [
			columnDict := sampleClass allClassTableColumns.
			columnDict at: 'oid' put: lightOidColumn.
			connection executeQuery: (connection queryToCreateTableNamed: sampleClass tableName withColumns:  columnDict)
		].
		sampleClass := sampleClass superclass.
	].! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 16:12'!
deleteObject
	| |
	"this is were the beauty of foreign key constraints kicks in - just delete the object in the base table"
	^self sampleObject class getConnection 
			removeObjectWithId: (self sampleObject oid) 
			fromTable: (self sampleObject class baseClass tableName)! !

!SqSaveClassTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:26'!
insertObject
	| connection baseClass columnDict lastOid klass |
	connection := self sampleObject class getConnection.
	baseClass := self sampleObject class baseClass.
	columnDict := Dictionary new.
	baseClass allClassTableColumns associationsDo: [:assoc |
		columnDict at: assoc value columnName put: (self sampleObject escapedValueForInstanceVariable: assoc key).	
	].
	connection inTransactionDo: [
		lastOid := connection storeColumns: columnDict inTable: baseClass tableName  andReturnOId: true.
		klass := self sampleObject class.
		[klass ~= baseClass] whileTrue: [
			columnDict := Dictionary new.
			klass allClassTableColumns associationsDo: [:assoc |
				columnDict at: assoc value columnName put: (self sampleObject escapedValueForInstanceVariable: assoc key).	
			].
			columnDict at: 'oid' put: lastOid.
			connection storeColumns: columnDict inTable: klass tableName.
			klass := klass superclass.
		].
	].
	^lastOid
	
	
	! !

SqSaveTableStructureHandler subclass: #SqSaveConcreteTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

SqSaveTableStructureHandler subclass: #SqSaveSingleTableInheritanceTableStructureHandler
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Base'!

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 11:28'!
buildSearchFor: instVars withValues: values
	| descrHandler searchDict descr targetClass baseClass typeField tableName columnName |
	
	descrHandler := self sampleObject descriptionHandler.
	targetClass := self sampleObject class.
	searchDict := Dictionary new.
	baseClass := targetClass baseClass.
	typeField := targetClass getConnection class sqSaveInheritanceTypeField.
	
	instVars withIndexDo: [:ivar :index |
		(ivar = 'oid') ifTrue: [
			tableName := baseClass tableName.
			columnName := 'oid'.
		] ifFalse: [
			descr := (descrHandler columnDescriptionFor: ivar).
			tableName :=  descr tableName.
			columnName := descr columnName.
		].		
		(searchDict at: tableName ifAbsentPut: Dictionary new) at: #AND ifAbsentPut: Set new.
		((searchDict at: tableName) at: #AND) add: (columnName -> (values at: index))
	].
	(searchDict at: baseClass tableName ifAbsentPut: Dictionary new) at: #OR ifAbsentPut: Set new.
	((searchDict at: baseClass tableName) at: #OR) add: (typeField -> targetClass name).
	targetClass allSubclasses do: [:sc |
		((searchDict at: baseClass tableName) at: #OR) add: (typeField -> sc name).	
	].
	^searchDict! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 15:57'!
createTableStructure
	| connection columnDictionary sampleClass |
	sampleClass := self sampleObject class.
	connection := sampleClass getConnection.
	columnDictionary := sampleClass allClassTableColumns.
	connection executeQuery: (connection queryToCreateTableNamed: sampleClass tableName withColumns: columnDictionary).! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 16:09'!
deleteObject
	| |
	^self sampleObject class getConnection 
			removeObjectWithId: (self sampleObject oid) 
			fromTable: (self sampleObject class tableName)
	! !

!SqSaveSingleTableInheritanceTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:34'!
insertObject
	| columnDict connection |
	columnDict := Dictionary new.
	connection := self sampleObject class getConnection.
	self sampleObject class allClassTableColumns associationsDo:[ :assoc |
		columnDict at: assoc value columnName put: (self sampleObject escapedValueForInstanceVariable: assoc key).	
	].
	^connection storeColumns: columnDict inTable: self sampleObject class tableName  andReturnOId: true.
	! !

!SqSaveTableStructureHandler class methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:08'!
for: anObject
	| inheritanceMode targetClass |
	inheritanceMode := (anObject class descriptionHandler inheritanceModeForClass: anObject class).
	targetClass := 'SqSave',inheritanceMode capitalized,'TableStructureHandler'.
	targetClass := Smalltalk at: targetClass asSymbol ifAbsent: [self error: 'Unknown inheritance Mode'].
	^(targetClass new)
		sampleObject: anObject;
		yourself.! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 17:07'!
buildSearchFor: instVars withValues: values
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 15:42'!
createTableStructure
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/15/2008 15:59'!
deleteObject
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:05'!
insertObject
	self subclassResponsibility! !

!SqSaveTableStructureHandler methodsFor: 'accessing' stamp: 'tk 7/8/2008 14:58'!
sampleObject
	^ sampleObject! !

!SqSaveTableStructureHandler methodsFor: 'accessing' stamp: 'tk 7/8/2008 14:58'!
sampleObject: anObject
	sampleObject := anObject! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionClass
	^#MANumberDescription! !

!Number methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:10'!
magritteDescriptionDefaultValue
	^'0'! !

!Number methodsFor: '*tksave' stamp: 'tk 5/20/2008 16:45'!
magritteDescriptionStandardValue
	^0! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionClass
	^#MADateDescription! !

!Date methodsFor: '*tksave' stamp: 'tk 5/21/2008 11:20'!
magritteDescriptionDefaultValue
	^'Date today'! !

!Collection methodsFor: '*tksave' stamp: 'tk 7/14/2008 19:02'!
join: joinString
	| joiner |
	joiner := joinString ifNil:[''] ifNotNil: [joinString].
	^String streamContents: [:s | self asStringOn: s delimiter: joiner]! !

TestCase subclass: #SqSaveBaseTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/14/2008 15:20'!
clearDatabase
	connection := SqSaveMySQLDriver 
		onHost: 'localhost'
		port: 3306
		withUser: 'thomas'
		password: 'test'
		database: 'squeak_test'.
	connection resetDatabase! !

!SqSaveBaseTest methodsFor: 'private' stamp: 'tk 7/4/2008 17:36'!
removeDescriptions
	| classes |
	classes := Set with: SqSaveTestObject.
	classes addAll: SqSaveTestObject allSubclasses.
	classes do: [ :curClass |
		curClass allInstVarNames do: [ :ivn | 
			(curClass class includesSelector: ivn asDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asDescriptionSelector
			].
			(curClass class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: [ 
				curClass class removeSelector: ivn asSqSaveDescriptionSelector
			].
		]
	].! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:07'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testMagritteDescriptorCreationOnSave
	| testObject |
	self removeDescriptions.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asDescriptionSelector) not.
	self assert: SqSaveTestObject descriptionTestString class = MAStringDescription.
	self assert: SqSaveTestObject descriptionTestDate class = MADateDescription.
	self assert: SqSaveTestObject descriptionTestInteger class = MANumberDescription! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/15/2008 18:26'!
testMagritteDescriptorUpdateOnSave
	| testObject |
	testObject := SqSaveTestObject new.
	testObject testSomething: SqSaveTestObjectChild new.
	testObject save.
	self assert: SqSaveTestObject persistenceDescriptionTestSomething associatedClass = SqSaveTestObjectChild name asString.
	testObject testSomething: SqSaveTestObject new.
	testObject save.
	self assert: SqSaveTestObject persistenceDescriptionTestSomething associatedClass = SqSaveTestObject name asString.! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/15/2008 11:30'!
testMagrittePersistenceDescriptorCreationOnSave
	| testObject description |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject
		testDate: Date today;
		testInteger: 42;
		testString: 'calculon';
		testSomething: SqSaveTestObject new.
	testObject save.
	description := SqSaveTestObject persistenceDescriptionTestInteger.
	self assert: description class = SqSaveColumnDescription.
	self assert: description sqlType = 'SMALLINT'.
	self assert: description columnName = 'test_integer'.
	self assert: description associatedClass isNil.
	self assert: description tableName = SqSaveTestObject name asSqSaveTableName.
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testNewRecordAttribute
	| obj obj2 |
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	self assert: obj newRecord.
	obj save.
	self assert: obj newRecord not.
	obj2 := SqSaveTestObject findByTestInteger: 42.
	self assert: obj2 newRecord not! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testObjectIdAssignment
	| testObject testObject2 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: testObject oid == 1.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 4.
	testObject2 save.
	self assert: testObject2 oid == 2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:19'!
testPersistenceDescriptorCreationOnSaveHappensOnlyInTheClassesDefiningTheVariable
	| testObject |
	self removeDescriptions.
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject testSubString: 'test'.
	testObject testExtremelyDeepSubString: 'test'. 
	testObject save.
	self assert: (SqSaveTestObject class includesSelector: 'testDate' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testInteger' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSomething' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObjectChild class includesSelector: 'testSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObjectEvenDeeperChild class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector).
	self assert: (SqSaveTestObject class includesSelector: 'testSubString' asSqSaveDescriptionSelector) not.
	self assert: (SqSaveTestObject class includesSelector: 'testExtremelyDeepSubString' asSqSaveDescriptionSelector) not.
	
	! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testSaveRelatedObjectAlongWithObject
	| testObject testObject2 result |
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	self assert: testObject2 newRecord.
	testObject save.
	self assert: testObject2 newRecord not.
	self assert: testObject2 oid isNil not.
	result := SqSaveTestObject findByTestInteger: 6.
	self assert: result = testObject2! !

!SqSaveBaseTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	self assert: SqSaveTestObject tableForClassExists not.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists! !

TestCase subclass: #SqSaveColumnTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveColumnTest methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 17:38'!
testCreationCode
	| column column2 |
	column := SqSaveColumnDescription new.
	column columnName: 'testColumn'.
	column sqlType: 'INTEGER'.
	column2 := Compiler evaluate: column creationCode.
	self assert: column2 class = SqSaveColumnDescription.
	self assert: column2 sqlType = 'INTEGER'.
	self assert: column2 columnName = 'testColumn'! !

TestCase subclass: #SqSaveConnectionManagerTest
	instanceVariableNames: 'connectionManager'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveConnectionManagerTest methodsFor: 'running' stamp: 'tk 6/24/2008 15:37'!
setUp
	connectionManager := SqSaveConnectionManager getInstance.! !

!SqSaveConnectionManagerTest methodsFor: 'tests' stamp: 'tk 7/14/2008 15:20'!
testAddConnectionSpecification
	| connectionSpecification connection |
	connectionManager connectionSpecificationDictionary: Dictionary new.
	connectionSpecification := SqSaveConnectionSpecification 
		user: 'thomas'
		password: 'test'
		port: 3306
		database: 'squeak_test'
		hostname: 'localhost'
		driver: #SqSaveMySQLDriver.
	connectionManager 
		setupConnectionSpecification: connectionSpecification
		for: 'TKSave'.
	self assert: (connectionManager connectionSpecificationDictionary includesKey: 'TKSave').
	self assert: (connectionManager connectionSpecificationDictionary at: 'TKSave') class == SqSaveConnectionSpecification.
	connection := connectionManager getConnectionForCategory: 'TKSave'.
	self assert: connection isNil not! !

TestCase subclass: #SqSaveDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 7/10/2008 17:00'!
testSqlTypeRecognition
	| handler |
	handler := SqSaveDescriptionHandler for: SqSaveTestObject new.
	self assert: (handler determineSqlTypeForObject: 42) = 'SMALLINT'.
	self assert: (handler determineSqlTypeForObject: SqSaveTestObject new) = 'INTEGER'.
	self assert: (handler determineSqlTypeForObject: SqSaveColumnDescription new) isNil.
	self assert: (handler determineSqlTypeForObject: true) = 'BOOLEAN'! !

TestCase subclass: #SqSaveInheritanceTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveInheritanceTest subclass: #SqSaveClassTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:06'!
setUp
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#classTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveClassTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/15/2008 18:24'!
testCascadingDelete
	| dbConnection result |
	"self testDestroyObjects.
	dbConnection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectChild name asSqSaveTableName , ' WHERE oid = 1'.
	self assert: result next not.
	[result next] whileTrue: [].
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObjectEvenDeeperChild name asSqSaveTableName , ' WHERE oid = 1'.
	self assert: result next not.
	[result next] whileTrue: [].
	"	! !

!SqSaveClassTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:38'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys size = 5.
	self assert: SqSaveTestObjectChild allClassTableColumns keys size = 1.
	self assert: SqSaveTestObjectEvenDeeperChild allClassTableColumns keys size = 1.! !

!SqSaveClassTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/30/2008 16:26'!
testTableNames
	self assert: SqSaveTestObject tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert: SqSaveTestObjectEvenDeeperChild tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.! !

SqSaveInheritanceTest subclass: #SqSaveConcreteTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveConcreteTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/30/2008 15:31'!
setUp
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#concreteTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveConcreteTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 7/7/2008 17:25'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys size = 4.
	self assert: SqSaveTestObjectChild allClassTableColumns keys size = 5.
	self assert: SqSaveTestObjectEvenDeeperChild allClassTableColumns keys size = 6.! !

!SqSaveConcreteTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/30/2008 16:24'!
testTableCreationOnSave
	| testObject |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	self assert: SqSaveTestObject tableForClassExists not.
	testObject testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 4.431253434.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists.
	! !

!SqSaveConcreteTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/30/2008 16:27'!
testTableNames
	self assert: SqSaveTestObject tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObjectChild name asSqSaveTableName.
	self assert: SqSaveTestObjectEvenDeeperChild tableName = SqSaveTestObjectEvenDeeperChild name asSqSaveTableName.! !

!SqSaveInheritanceTest class methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:08'!
shouldInheritSelectors
	^true! !

!SqSaveInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:20'!
clearDatabase
	connection := SqSaveMySQLDriver 
		onHost: 'localhost'
		port: 3306
		withUser: 'thomas'
		password: 'test'
		database: 'squeak_test'.
	connection resetDatabase! !

!SqSaveInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:05'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/1/2008 13:10'!
testCorrectObjectCreation
	| testObject1 testObject2 result |
	self clearDatabase.
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	result := SqSaveTestObject findByTestInteger: 42.
	self assert: result class = SqSaveTestObject.
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save.
	result := SqSaveTestObject findByTestInteger: 21.
	self assert: result class = SqSaveTestObjectChild! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/15/2008 16:18'!
testDestroyObjects
	| testObject searchResult newSearchResult |
	self clearDatabase.
	testObject := (SqSaveTestObjectEvenDeeperChild new)
		testString: 'Hello World';
		testInteger: 42;
		testSubString: 'SubString';
		testExtremelyDeepSubString: 'DeeperSubString'.
	testObject save.
	searchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (searchResult isNil not).
	searchResult destroy.
	newSearchResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (newSearchResult isNil).! !

!SqSaveInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 16:32'!
testGetPersistedInstanceVariables
	| |
	self assert: SqSaveTestObject persistedInstVars size = 4.
	self assert: SqSaveTestObjectChild persistedInstVars size = 5.
	self assert: SqSaveTestObjectEvenDeeperChild persistedInstVars size = 6.	
	self assert: SqSaveTestObject persistedInstVars size < SqSaveTestObjectChild persistedInstVars size.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'testUnstoredVariable') not.
	self assert: (SqSaveTestObjectChild persistedInstVars includes: 'oid') not.! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/14/2008 18:47'!
testNamingBasedSearch
	| testObject searchResult1 searchResult2 searchResult3 searchResult0 |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject save.
	searchResult0 := SqSaveTestObject 
		findByTestInteger: 5
		andTestDate: Date today.
	searchResult1 := SqSaveTestObject findByTestInteger: 5.
	searchResult2 := SqSaveTestObject 
		findByTestDate: Date today
		andTestString: 'test'.
	searchResult3 := SqSaveTestObject findByTestString: 'test'.
	self assert: searchResult0 isNil not.
	self assert: searchResult0 testInteger = 5.
	self assert: searchResult0 testDate = Date today.
	self assert: searchResult0 testString = 'test'.
	self assert: testObject = searchResult1.
	self assert: testObject = searchResult2.
	self assert: testObject = searchResult3! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/1/2008 13:58'!
testObjectCompleteness
	| testObject testResult |
	self clearDatabase.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testInteger: 42;
		testString: 'fortyTwo';
		testDate: Date today;
		testSomething: 3;
		testSubString: 'twentyOne';
		testExtremelyDeepSubString: 'elevenAndAHalf'.
	testObject save.
	testResult := SqSaveTestObjectEvenDeeperChild findByTestInteger: 42.
	self assert: (testResult isNil not).
	self assert: (testResult testInteger =  42).
	self assert: (testResult testString = 'fortyTwo').
	self assert: (testResult testDate = Date today).
	self assert: (testResult testSomething = 3).
	self assert: (testResult testSubString = 'twentyOne').
	self assert: (testResult testExtremelyDeepSubString = 'elevenAndAHalf').

	! !

!SqSaveInheritanceTest methodsFor: 'tests' stamp: 'tk 7/15/2008 11:30'!
testRelationNamingBasedSearch
	| testObject testObject2 result |
	self clearDatabase.
	testObject := SqSaveTestObject new.
	testObject testDate: Date today.
	testObject testInteger: 5.
	testObject testString: 'test'.
	testObject2 := SqSaveTestObject new.
	testObject2 testInteger: 6.
	testObject2 testString: 'test2'.
	testObject testSomething: testObject2.
	testObject save.
	result := SqSaveTestObject findByTestSomething: testObject2.
	self assert: result = testObject! !

!SqSaveInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 7/1/2008 13:07'!
testSomething
	self assert: true.! !

SqSaveInheritanceTest subclass: #SqSaveSingleTableInheritanceTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceTest methodsFor: 'as yet unclassified' stamp: 'tk 6/26/2008 18:05'!
setUp
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#singleTableInheritance'.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/15/2008 16:19'!
testCascadingDelete
	self testDestroyObjects.
	! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/7/2008 17:17'!
testGetClassTableColumns
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectChild allClassTableColumns keys.
	self assert: SqSaveTestObject allClassTableColumns keys = SqSaveTestObjectEvenDeeperChild allClassTableColumns keys.! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 6/26/2008 18:00'!
testSaveSubclassWithSingleTableInheritance
	| testObject |
	self clearDatabase.
	self assert: SqSaveTestObjectChild tableName = SqSaveTestObject name asSqSaveTableName.
	self assert: SqSaveTestObjectChild tableForClassExists not.
	testObject := SqSaveTestObjectChild new.
	testObject testSubString: 'Subtest'.
	testObject save.
	self assert: SqSaveTestObjectChild tableForClassExists! !

!SqSaveSingleTableInheritanceTest methodsFor: 'tests' stamp: 'tk 7/7/2008 16:51'!
testTypeParameter
	| testObject1 testObject2 dbConnection result resultDict |
	self clearDatabase.
	testObject1 := SqSaveTestObject new.
	testObject1 testInteger: 42.
	testObject1 save.
	dbConnection := SqSaveConnectionManager getInstance getConnectionForCategory: 'TKSave'.
	result := dbConnection executeQuery: 'SELECT * FROM ' , SqSaveTestObject name asSqSaveTableName , ' WHERE test_integer = 42'.
	[ result next ] whileTrue: 
		[ resultDict := result currentRowAsDictionary.
		self assert: (resultDict at: dbConnection class sqSaveInheritanceTypeField) = SqSaveTestObject name asString ].
	testObject2 := SqSaveTestObjectChild new.
	testObject2 testInteger: 21.
	testObject2 save! !

TestCase subclass: #SqSaveMagritteDescriptionHandlerTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'running' stamp: 'tk 6/26/2008 17:53'!
setUp
	SqSaveTestObject instVarNames do: 
		[ :ivn | 
		(SqSaveTestObject class includesSelector: ivn asDescriptionSelector) ifTrue: [ SqSaveTestObject class removeSelector: ivn asDescriptionSelector ].
		(SqSaveTestObject class includesSelector: ivn asSqSaveDescriptionSelector) ifTrue: 
			[ SqSaveTestObject class removeSelector: ivn asSqSaveDescriptionSelector ] ]! !

!SqSaveMagritteDescriptionHandlerTest methodsFor: 'tests' stamp: 'tk 6/26/2008 17:53'!
testCreateDescriptionMethods
	| obj |
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate) not.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not.
	obj := SqSaveTestObject new.
	obj testInteger: 42.
	obj testString: 'test'.
	obj testDate: Date today.
	(SqSaveMagritteDescriptionHandler for: obj) createDescriptionMethods.
	self assert: (SqSaveTestObject respondsTo: #descriptionTestInteger).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestString).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestDate).
	self assert: (SqSaveTestObject respondsTo: #descriptionTestSomething) not! !

TestCase subclass: #SqSaveStringExtensionTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 5/15/2008 15:46'!
testAsDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asDescriptionSelector = #descriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/19/2008 15:34'!
testAsSqSaveDescriptionSelector
	| testString |
	testString := 'instanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'InstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionInstanceVariable).
	testString := 'aInstanceVariable'.
	self assert: (testString asSqSaveDescriptionSelector = #persistenceDescriptionAInstanceVariable).
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 6/24/2008 15:33'!
testAsSqSaveTableName
	| testString |
	testString := 'TKSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'tk_save_test_objects').
	testString := 'SqSaveTestObject'.
	self assert: (testString asSqSaveTableName = 'sq_save_test_objects').
	testString := 'SqSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'sqsave_test_objects').
	testString := 'TKSAVETestObject'.
	self assert: (testString asSqSaveTableName = 'tksave_test_objects').
	! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/14/2008 17:45'!
testCollectionJoin
	self assert: ((#('hallo' 'welt') join: '-') = 'hallo-welt').
	self assert: ((#('hallo' 'welt') join: '') = 'hallowelt').
	self assert: ((#('hallo' 'welt') join: nil) = 'hallowelt')! !

!SqSaveStringExtensionTests methodsFor: 'tests' stamp: 'tk 7/7/2008 16:48'!
testDecamelized
	self assert: 'sq_save_type_field' decamelized = 'sq_save_type_field'.
	self assert: 'SqSaveTypeField' decamelized = 'sq_save_type_field'.! !

TestCase subclass: #SqSaveTableCreatorTest
	instanceVariableNames: 'connection'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveTableCreatorTest subclass: #SqSaveClassTableInheritanceTableCreatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveClassTableInheritanceTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 16:18'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524343343;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	
	self assert: SqSaveTestObject tableForClassExists.
	self assert: SqSaveTestObjectChild tableForClassExists.
	self assert: SqSaveTestObjectEvenDeeperChild tableForClassExists.! !

SqSaveTableCreatorTest subclass: #SqSaveConcreteTableInheritanceTableCreatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

SqSaveTableCreatorTest subclass: #SqSaveSingleTableInheritanceTableCreatorTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'TKSave-Tests'!

!SqSaveSingleTableInheritanceTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 16:33'!
testTableCreation
	| testObject |
	self clearDatabase.
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	testObject := SqSaveTestObjectEvenDeeperChild new.
	testObject testString: 'test';
		testInteger: 42;
		testDate: Date today;
		testSomething: 4.524;
		testSubString: 'FortyTwo';
		testExtremelyDeepSubString: 'FortyTwoSquared'.
	testObject save.
	self assert: SqSaveTestObject tableForClassExists.! !

!SqSaveTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:20'!
clearDatabase
	connection := SqSaveMySQLDriver 
		onHost: 'localhost'
		port: 3306
		withUser: 'thomas'
		password: 'test'
		database: 'squeak_test'.
	connection resetDatabase! !

!SqSaveTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 15:26'!
descriptorMethodCategory
	^'persistence-description'! !

!SqSaveTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/8/2008 15:29'!
setTestObjectInheritanceModeTo: aSymbolString
	| code |
	code := 'persistenceInheritanceMode',String cr,String tab, '^#',aSymbolString.
	(SqSaveTestObject organization categories includes: (self descriptorMethodCategory)) ifTrue: [
		SqSaveTestObject organization addCategory: (self descriptorMethodCategory).
	].
	SqSaveTestObject class compile: code classified: (self descriptorMethodCategory).! !

!SqSaveTableCreatorTest methodsFor: 'as yet unclassified' stamp: 'tk 7/14/2008 15:04'!
testCorrectClassChoosing
	| sampleObject |
	self setTestObjectInheritanceModeTo: #singleTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSaveTableStructureHandler for: sampleObject) class = SqSaveSingleTableInheritanceTableStructureHandler.
	self setTestObjectInheritanceModeTo: #classTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSaveTableStructureHandler for: sampleObject) class = SqSaveClassTableInheritanceTableStructureHandler.
	self setTestObjectInheritanceModeTo: #concreteTableInheritance.
	sampleObject := SqSaveTestObject new.
	self assert: (SqSaveTableStructureHandler for: sampleObject) class = SqSaveConcreteTableInheritanceTableStructureHandler! !
